// (c) Copyright Microsoft Corporation.
// This source is subject to the Microsoft Permissive License.
// See http://www.microsoft.com/resources/sharedsource/licensingbasics/sharedsourcelicenses.mspx.
// All other rights reserved.


using System;
using System.Web.UI.WebControls;
using System.Web.UI;
using System.ComponentModel;
using Microsoft.AtlasControlExtender;

namespace Dflying.Atlas.ControlTookit.ValidateUserName
{
    [DefaultProperty("CheckResultLabelID")]
    public class ValidateUserNameProperties : TargetControlPropertiesBase<Control>
    {

        [DefaultValue("")]
        [IDReferenceProperty(typeof(WebControl))]
        [RequiredProperty()]
        public string CheckResultLabelID
        {
            get
            {
                return GetPropertyStringValue("CheckResultLabelID");
            }
            set
            {
                SetPropertyStringValue("CheckResultLabelID", value);
            }
        }

        public string ServiceName
        {
            get
            {
                return GetPropertyStringValue("ServiceName");
            }
            set
            {
                SetPropertyStringValue("ServiceName", value);
            }
        }

        public string MethodName
        {
            get
            {
                return GetPropertyStringValue("MethodName");
            }
            set
            {
                SetPropertyStringValue("MethodName", value);
            }
        }

        [DefaultValue("You can use this user name.")]
        public string ValidMessage
        {
            get
            {
                return GetPropertyStringValue("ValidMessage");
            }
            set
            {
                SetPropertyStringValue("ValidMessage", value);
            }
        }

        [DefaultValue("This user name has already been used, please choose another.")]
        public string InvalidMessage
        {
            get
            {
                return GetPropertyStringValue("InvalidMessage");
            }
            set
            {
                SetPropertyStringValue("InvalidMessage", value);
            }
        }
    }
}
