// (c) Copyright Microsoft Corporation.
// This source is subject to the Microsoft Permissive License.
// See http://www.microsoft.com/resources/sharedsource/licensingbasics/sharedsourcelicenses.mspx.
// All other rights reserved.

Type.registerNamespace('Dflying.Atlas.ControlTookit.ValidateUserName');

Dflying.Atlas.ControlTookit.ValidateUserName.ValidateUserNameBehavior = function() {
    Dflying.Atlas.ControlTookit.ValidateUserName.ValidateUserNameBehavior.initializeBase(this);
    
    var _blurHandler;
    
    var _CheckResultLabelID;
    var _checkResultLabel;
    var _ServiceName;
    var _MethodName;
    var _ValidMessage = "You can use this user name.";
    var _InvalidMessage = "This user name has already been used, please choose another.";
    
    this.get_CheckResultLabelID = function() {
        return _CheckResultLabelID;
    }
    this.set_CheckResultLabelID = function(value) {
        if (_CheckResultLabelID != value) {
            _checkResultLabel = $(value);
debug.assert(_checkResultLabel != null, "CheckResultLabelID must be set to a valid DOM element.");
            _CheckResultLabelID = value;
            this.raisePropertyChanged('CheckResultLabelID');
        }
    }
    this.get_ServiceName = function() {
        return _ServiceName;
    }
    this.set_ServiceName = function(value) {
        if (_ServiceName != value) {
            _ServiceName = value;
            this.raisePropertyChanged('ServiceName');
        }
    }
    this.get_MethodName = function() {
        return _MethodName;
    }
    this.set_MethodName = function(value) {
        if (_MethodName != value) {
            _MethodName = value;
            this.raisePropertyChanged('MethodName');
        }
    }
    this.get_ValidMessage = function() {
        return _ValidMessage;
    }
    this.set_ValidMessage = function(value) {
        if (_ValidMessage != value) {
            _ValidMessage = value;
            this.raisePropertyChanged('ValidMessage');
        }
    }
    this.get_InvalidMessage = function() {
        return _InvalidMessage;
    }
    this.set_InvalidMessage = function(value) {
        if (_InvalidMessage != value) {
            _InvalidMessage = value;
            this.raisePropertyChanged('InvalidMessage');
        }
    }
    
    this.initialize = function() {
        Dflying.Atlas.ControlTookit.ValidateUserName.ValidateUserNameBehavior.callBaseMethod(this, 'initialize');
       
        _blurHandler = Function.createDelegate(this, blurHandler);
        this.control.element.attachEvent('onblur', _blurHandler);         
    }
    
    this.dispose = function() {
       
        if (_blurHandler) {
            this.control.element.detachEvent('onblur', _blurHandler);
            _blurHandler = null;
        }
        
        Dflying.Atlas.ControlTookit.ValidateUserName.ValidateUserNameBehavior.callBaseMethod(this, 'dispose');
    }
    
    this.getDescriptor = function() {
        var td = Dflying.Atlas.ControlTookit.ValidateUserName.ValidateUserNameBehavior.callBaseMethod(this, 'getDescriptor');
        
        td.addProperty('CheckResultLabelID', String);
        td.addProperty('ServiceName', String);
        td.addProperty('MethodName', String);
        td.addProperty('ValidMessage', String);
        td.addProperty('InvalidMessage', String);
               
        return td;
    }
    
    function blurHandler() {
        if (this.control.element.value == '') {
            _checkResultLabel.innerHTML = '';
            return;
        }
        
        Sys.Net.ServiceMethod.invoke(
            _ServiceName, 
            _MethodName, 
            '',
            { userNameCandidate : this.control.element.value},
            _onMethodComplete
        );
    }
    
    function _onMethodComplete(result)
    {
        _checkResultLabel.innerHTML = result ? _ValidMessage : _InvalidMessage;
    }   
        
    this.getClientState = function() {
        var value = Dflying.Atlas.ControlTookit.ValidateUserName.ValidateUserNameBehavior.callBaseMethod(this, 'get_ClientState');                
        if (value == '') value = null;
        return value;
    }
     
    this.setClientState = function(value) {
        return Dflying.Atlas.ControlTookit.ValidateUserName.ValidateUserNameBehavior.callBaseMethod(this, 'set_ClientState',[value]);                
    }
}

Dflying.Atlas.ControlTookit.ValidateUserName.ValidateUserNameBehavior.registerSealedClass('Dflying.Atlas.ControlTookit.ValidateUserName.ValidateUserNameBehavior', Microsoft.AtlasControlExtender.BehaviorBase);
Sys.TypeDescriptor.addType('dflying', 'ValidateUserNameBehavior', Dflying.Atlas.ControlTookit.ValidateUserName.ValidateUserNameBehavior);
